curl --request POST \
--url https://semgrep.dev/api/sca/deployments/{deploymentId}/sbom_async \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"deploymentId": 123,
"repositoryId": 123,
"ref": "refs/pull/1234/merge",
"formatVersion": {
"format": "SBOM_FORMAT_CYCLONEDX",
"cyclonedxVersion": "SBOM_CYCLONE_DX_VERSION_V1_7"
},
"sbomOutputFormat": "SBOM_OUTPUT_FORMAT_JSON",
"metadataSupplier": {
"name": "<string>",
"url": "<string>",
"contact": {
"name": "<string>",
"email": "<string>",
"phone": "<string>"
}
}
}
'import requests
url = "https://semgrep.dev/api/sca/deployments/{deploymentId}/sbom_async"
payload = {
"deploymentId": 123,
"repositoryId": 123,
"ref": "refs/pull/1234/merge",
"formatVersion": {
"format": "SBOM_FORMAT_CYCLONEDX",
"cyclonedxVersion": "SBOM_CYCLONE_DX_VERSION_V1_7"
},
"sbomOutputFormat": "SBOM_OUTPUT_FORMAT_JSON",
"metadataSupplier": {
"name": "<string>",
"url": "<string>",
"contact": {
"name": "<string>",
"email": "<string>",
"phone": "<string>"
}
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
deploymentId: 123,
repositoryId: 123,
ref: 'refs/pull/1234/merge',
formatVersion: {
format: 'SBOM_FORMAT_CYCLONEDX',
cyclonedxVersion: 'SBOM_CYCLONE_DX_VERSION_V1_7'
},
sbomOutputFormat: 'SBOM_OUTPUT_FORMAT_JSON',
metadataSupplier: {
name: '<string>',
url: '<string>',
contact: {name: '<string>', email: '<string>', phone: '<string>'}
}
})
};
fetch('https://semgrep.dev/api/sca/deployments/{deploymentId}/sbom_async', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"taskTokenJwt": "<string>"
}Generate a project's SBOM
Starts a job to asynchronously generate a Software Bill of Materials (SBOM) for a given project. It does not return the SBOM itself, only schedules the job and returns a task JWT.
The Tasks Service can accept the task token to get the status and result of the job.
Authorizations
Get access to data with your API token. Example header:
Authorization: Bearer 2991e2fb4b540fe75b8f90677b0b892b6314e4961cb001fe6eb452eee248a628
The token can be provisioned from the Tokens section in your Settings, and requires explicitly enabling Web API access.
Path Parameters
Deployment ID (numeric). Example: 123. Can be found at /deployments, or in your Settings in the web UI.
123
Body
This is the API message proto for GenerateSbomAsync, but it should stay
roughly in-sync with the product message GenerateSbomRequest.
Deployment ID (numeric). Example: 123. Can be found at /deployments, or in your Settings in the web UI.
123
Project ID to export SBOM for. Use Projects endpoints to find IDs.
123
Branch to export SBOM for.
"refs/pull/1234/merge"
Show child attributes
Show child attributes
Output format for the SBOM file.
| value | description |
|---|---|
| SBOM_OUTPUT_FORMAT_XML | |
| SBOM_OUTPUT_FORMAT_JSON |
SBOM_OUTPUT_FORMAT_XML, SBOM_OUTPUT_FORMAT_JSON "SBOM_OUTPUT_FORMAT_JSON"
Type of component being documented.
| value | description |
|---|---|
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_APPLICATION | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_FRAMEWORK | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_LIBRARY | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_CONTAINER | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_PLATFORM | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_OPERATING_SYSTEM | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_DEVICE | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_DEVICE_DRIVER | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_FIRMWARE | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_FILE | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_MACHINE_LEARNING_MODEL | |
| SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_DATA |
SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_APPLICATION, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_FRAMEWORK, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_LIBRARY, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_CONTAINER, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_PLATFORM, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_OPERATING_SYSTEM, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_DEVICE, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_DEVICE_DRIVER, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_FIRMWARE, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_FILE, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_MACHINE_LEARNING_MODEL, SBOM_METADATA_COMPONENT_TYPE_CYCLONE_DX_V15_DATA Show child attributes
Show child attributes
Response
Accepted
Task token to track the status and result of the export job.
Was this page helpful?